# Copyright 2021 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import fields, models


class AccAccountSurplusWizard(models.TransientModel):
    _name = "acc.account.surplus.wizard"
    _description = "Facturation de surplus"

    # ------------------------------------------------------
    # Fields declaration
    # ------------------------------------------------------
    start_date = fields.Date("Date de début")
    account_periodicity = fields.Selection(
        [("3", "Trimestrielle"), ("12", "Annuelle")],
        string="Périodicité Facturation",
        default="trimestrial",
    )
    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------
    def create_invoice_surplus(self):
        context = dict(self._context or {})
        if context.get("active_ids", False):
            self.env["acc.operation"].browse(
                context.get("active_ids")
            ).create_account_surplus(self.start_date, self.account_periodicity)
        return {"type": "ir.actions.act_window_close"}

    # ------------------------------------------------------
    # Business methods
    # ------------------------------------------------------
